/* lab6a.c */

#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>

#define I_MAX_THREADS   254
#define SZ_FORMATO      "Formato: p <#porcoes> <#canibais> <#cozinheiros>\n"
#define SZ_MAX_THREADS  "O maximo de threads permitido e' %d\n"
#define SZ_POS_PORCOES  "O numero de porcoes deve ser positivo\n"
#define SZ_ERRO_CRIA    "Erro na criacao do thread %d\n"
#define SZ_NUM_THREADS  "Numero de threads %d\n"
#define SZ_COMENDO      "Canibal %d esta' comendo\n"
#define SZ_SERVINDO     "Canibal %d esta' se servindo\n"
#define SZ_COZINHANDO   "Cozinheiro %d esta' cozinhando\n"
#define SZ_ENCHENDO     "Cozinheiro %d esta' enchendo a travessa\n"


int   porcoes        = 0 , /* numero de porcoes atual */
      P                  , /* porcoes que o cozinheiro coloca na travessa */
      n                  , /* numero de canibais */
      m                  , /* numero de cozinheiros */
      iCanibalEsp    = 0 ,
      iCozinheiroEsp = 0 ;
sem_t SemExcMutua        ,
      SemCanibal         ,
      SemCozinheiro      ;


void* ProcessoCanibal( void* MeuId ) ;

void* ProcessoCozinheiro( void* MeuId ) ;

void ServirTravessa( int iMeuId ) ;

void ComerComida( int iMeuId ) ;

void EncherTravessa( int iMeuId ) ;

void CozinharComida( int iMeuId ) ;


void* ProcessoCanibal( void* MeuId ) {
   while ( 1 ) {
      ServirTravessa( *( int* )MeuId ) ;
      ComerComida( *( int* )MeuId ) ;
   } /* while */
} /* ProcessoCanibal */


void* ProcessoCozinheiro( void* MeuId ) {
   while ( 1 ) {
      CozinharComida( *( int* )MeuId ) ;
      EncherTravessa( *( int* )MeuId ) ;
   } /* while */
} /* ProcessoCozinheiro */


void ServirTravessa( int iMeuId ) {

   /* < await( porcoes > 0 ) porcoes-- ; > */
   
   sem_wait( &SemExcMutua ) ;

   if ( porcoes == 0 ) {
      iCanibalEsp++ ;
      sem_post( &SemExcMutua ) ;
      sem_wait( &SemCanibal ) ;
      iCanibalEsp-- ;
   } /* if */

   printf( SZ_SERVINDO, iMeuId ) ;
   porcoes-- ;

   /* SIGNAL ; */
   
   if ( iCanibalEsp > 0 
     && porcoes > 0 ) {
      sem_post( &SemCanibal ) ;

   } else {
      if ( iCozinheiroEsp > 0
        && porcoes == 0 ) {
         sem_post( &SemCozinheiro ) ;
   
      } else {
         sem_post( &SemExcMutua ) ;
   
      } /* if */    
   
   } /* if */

} /* ServirTravessa */
      

void ComerComida( int iMeuId ) {
   unsigned long int i ;
   printf( SZ_COMENDO, iMeuId ) ;
   for ( i = 0 ; i < 1000000L * iMeuId ; i++ ) { }
} /* ComerComida */


void EncherTravessa( int iMeuId ) {

   /* < await( porcoes == 0 ) porcoes = P ; > */

   sem_wait( &SemExcMutua ) ;

   if ( porcoes > 0 ) {
      iCozinheiroEsp++ ;
      sem_post( &SemExcMutua ) ;
      sem_wait( &SemCozinheiro ) ;
      iCozinheiroEsp-- ;
   } /* if */

   printf( SZ_ENCHENDO, iMeuId ) ;
   porcoes = P ;
 
   /* SIGNAL ; */

   if ( iCanibalEsp > 0 ) {
      sem_post( &SemCanibal ) ;
   } else {
      sem_post( &SemExcMutua ) ;
   } /* if */    

} /* EncherTravessa */


void CozinharComida( int iMeuId ) {
   unsigned long int i ;
   printf( SZ_COZINHANDO, iMeuId ) ;
   for ( i = 0 ; i < 1000000L * iMeuId ; i++ ) { } 

} /* CozinharComida */


/* SIGNAL ;
   if ( iCanibalEsp > 0 
     && porcoes > 0 ) {
      sem_post( &SemCanibal ) ;

   } else {
      if ( iCozinheiroEsp > 0
        && porcoes == 0 ) {
         sem_post( &SemCozinheiro ) ;
   
      } else {
         sem_post( &SemExcMutua ) ;
   
      }     
   
   } */


int main( int   argc    ,
          char* argv[ ]  ) {
   int       i                       ,
             iErro                   ;
   int*      pMeuId                  ;
   pthread_t Thread[ I_MAX_THREADS ] ;

   if ( argc != 4 ) {
      printf( SZ_FORMATO ) ;
      return 0 ;
   } /* if */

   P = atoi( argv[ 1 ] ) ;
   n = atoi( argv[ 2 ] ) ;
   m = atoi( argv[ 3 ] ) ;

   if ( n + m > I_MAX_THREADS ) { 
      printf( SZ_MAX_THREADS, I_MAX_THREADS ) ;
      return 0 ;
   } /* if */  

   if ( P <= 0 ) {
      printf( SZ_POS_PORCOES ) ;
      return 0 ;
   } /* if */

   printf( SZ_NUM_THREADS, n + m ) ;

   sem_init( &SemExcMutua, 0, 1 ) ;
   sem_init( &SemCanibal, 0, 0 ) ;
   sem_init( &SemCozinheiro, 0, 0 ) ;

   for ( i = 0 ; i < n + m ; i++ ) {
      pMeuId = ( int* )malloc( sizeof( int ) ) ;
      *pMeuId = i ;

      if ( i < n ) {
         iErro = pthread_create( &Thread[ i ], NULL, ProcessoCanibal,
                                                     ( void* )( pMeuId ) ) ;
      } else {
         iErro = pthread_create( &Thread[ i ], NULL, ProcessoCozinheiro,
                                                     ( void* )( pMeuId ) ) ;
      } /* if */ 

      if ( iErro != 0 ) {
         printf( SZ_ERRO_CRIA, i ) ;
         return 1 ;
      } /* if */
   } /* for */

   pthread_exit( NULL ) ;

   return 0 ;
}
